#ifndef _FILTER_H
#define _FILTER_H

#include "filters/filter_interface.h"
#include "misc.h" /* abook_list */

#define	FILTNAME_LEN	8

#define	PATH_FILTERS_IN_BUILD_TREE	"./filters/.libs"

enum filter_actions {
	FILTER_IMPORT,
	FILTER_EXPORT,
};

typedef int (import_func_t) (FILE *);
typedef int (export_func_t) (FILE *, struct db_enumerator);
typedef struct filter_ops *(init_func_t) (struct abook_ops *, abook_list *);

void		import_database();
int             import_file(char filtname[FILTNAME_LEN], char *filename);

void		export_database();
int             export_file(char filtname[FILTNAME_LEN], char *filename);
int		fexport(char filtname[FILTNAME_LEN], FILE *handle,
		int enum_mode);

void		print_filters();

#endif
