#ifndef _OPTIONS_H
#define _OPTIONS_H

/* Prefix for operations within filter modules scope. */
#ifndef F_OP
#define F_OP(x)	x
#endif

#if 0
typedef int bool;
#else
#	include <abook_curses.h> /* bool */
#endif

/*
 * option types
 */

enum opt_type {
	OT_BOOL,
	OT_STR,
	OT_INT
};

/*
 * bool options
 */

enum bool_opts {
	BOOL_AUTOSAVE,
	BOOL_SHOW_ALL_EMAILS,
	BOOL_MUTT_RETURN_ALL_EMAILS,
	BOOL_USE_ASCII_ONLY,
	BOOL_ADD_EMAIL_PREVENT_DUPLICATES,
	BOOL_SHOW_CURSOR,
	BOOL_MAX
};

/*
 * int options
 */

enum int_opts {
	INT_EMAILPOS,
	INT_EXTRAPOS,
	INT_MAXIMUM /* INT_MAX conflicts on some systems */
};

/*
 * string options
 */

enum str_opts {
	STR_EXTRA_COLUMN,
	STR_EXTRA_ALTERNATIVE,
	STR_MUTT_COMMAND,
	STR_PRINT_COMMAND,
	STR_WWW_COMMAND,
	STR_ADDRESS_STYLE,
	STR_PRESERVE_FIELDS,
	STR_SORT_FIELD,
	STR_MAX
};

union opt_value {
	int int_v;
	bool bool_v;
	char *str_v;
};

union opt_value	opt_get_value(enum opt_type type, int opt);
#define opt_get_int(opt)	F_OP(opt_get_value(OT_INT, opt).int_v)
#define opt_get_bool(opt)	F_OP(opt_get_value(OT_BOOL, opt).bool_v)
#define opt_get_str(opt)	F_OP(opt_get_value(OT_STR, opt).str_v)
void		init_opts();
void		free_opts();
int		load_opts(char *filename);

#endif
